/*   Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License. */

/*
	The Definitive Guide to HTML5 WebSocket	
*/

// ActiveMQ STOMP  URL
var url = "ws://0.0.0.0:61614/stomp";
// ActiveMQ ڸ ȣ. ⺻    guest̴.
var un, pw = "guest";

var client, src, dest;

// /  ʰ ƿԴ  ¸  
var hasUserPicked, hasOpponentPicked = false;

// ÷̾ 2 ǥõ  ư ÷̾ 2  Ÿ  ǥϴ HTML ڵ
var opponentsBtns = '<button id="opponentScissorsBtn" name="opponentScissors" disabled="disabled"></button>' + '<button id="opponentRockBtn" name="opponentRock" disabled="disabled"></button>' + '<button id="opponentPaperBtn" name="opponentPaper" disabled="disabled"></button>';
var opponentsPick;

// ÷̾ 1  ư Ÿ 
var rockBtn, paperBtn, scissorsBtn;

//     ϴ ˻ؼ, ϸ ڸ Է ޴ ʵ尡 ȴ.
$(document).ready(function() {
    if (!window.WebSocket) {
        var msg = "    ʽϴ.   α׷    ϴ.";
        $("#nameFields").css("visibility", "hidden");
        $("#instructions").css("visibility", "visible");
        $("#instructions").html(msg);
    }
});

//  ϴ Լ. ÷̾ 1 ÷̾ 2 ̸ ۵Ǵ  ȣ
var startGame = function() {
    // ̸ Է ʵ带 Ȱȭ
    $("#myName").attr("disabled", "disabled");
    $("#opponentName").attr("disabled", "disabled");
    $("#goBtn").attr("disabled", "disabled");
    // ȳ  ư ̰ 
    $("#instructions").css("visibility", "visible");
    $("#buttons").css("visibility", "visible");
    //   ť Է  ÷̾ ̸ ״ 
    dest = "/queue/" + $("#opponentName").val();
    src = "/queue/" + $("#myName").val();
    connect();
};

//  ϴ Լ
var connect = function() {
    client = Stomp.client(url);
    client.connect(un, pw, onconnect, onerror);
};

//  Ǹ ȣǴ Լ
var onconnect = function() {
    console.log(url + " ƽϴ");
    client.subscribe(src, function(message) {
        console.log("ŵ ޽: " + message.body);
        // ŵǴ ޽ ÷̾ 2   Ÿ.
        //  ÷̾ 2 ư ׸.
        // ÷̾ 1 ʰ  ƿ ʾ ư  div ߰,
        // ʰ ƿ  ǥѴ.
        hasOpponentPicked = true;
        if (!hasUserPicked) {
            $("#opponentsButtons").css("visibility", "hidden");
            $("#instructions").html("<p>   ٸϴ. ϳ ϼ!</p>");
        } else {
            $("#instructions").html("<p>:</p>");
            client.disconnect( function() {
                console.log(" ƽϴ...");
            })
        }
        $("#opponentsButtons").html(opponentsBtns);
        switch (message.body) {
            case "scissors" :
                opponentsPick = "#opponentScissorsBtn";
                break;
            case "rock"     :
                opponentsPick = "#opponentRockBtn";
                break;
            case "paper"    :
                opponentsPick = "#opponentPaperBtn";
                break;
        }
        $(opponentsPick).css("background-color", "yellow");
    });
    console.log(src + " ߽ϴ");
};

var onerror = function(error) {
    console.log(error);
};

var buttonClicked = function(btn) {
    client.send(dest, null, btn.name);
    hasUserPicked = true;
    console.log("۽ ޽: " + btn.name);

    // ÷̾  Ÿ  ư   ҴѴ.
    //  ư Ŭ Ұϰ Ȱȭ
    $("#" + btn.id).css("background-color", "orange");
    $("#rockBtn").attr("disabled", "disabled");
    $("#paperBtn").attr("disabled", "disabled");
    $("#scissorsBtn").attr("disabled", "disabled");
    // ÷̾ 2  ߴ ˻ؼ,  onconnect Լ ̸ ׷Ҵ ư ǥ
    if (hasOpponentPicked) {
        $("#opponentsButtons").css("visibility", "visible");
        $("#instructions").html("<p>:</p>");
        client.disconnect(function() {
            onerror = function() {};
            console.log(" ƽϴ...");
        });
    } else {
        $("#instructions").html("<p>  ٸϴ...</p>");
    }
};
